/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatadogActionConnectionConfig extends cdktf.TerraformMetaArguments {
    /**
    * ID for Connection.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/action_connection#id DataDatadogActionConnection#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id: string;
    /**
    * http block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/action_connection#http DataDatadogActionConnection#http}
    */
    readonly http?: DataDatadogActionConnectionHttp;
}
export interface DataDatadogActionConnectionAwsAssumeRole {
}
export declare function dataDatadogActionConnectionAwsAssumeRoleToTerraform(struct?: DataDatadogActionConnectionAwsAssumeRole | cdktf.IResolvable): any;
export declare function dataDatadogActionConnectionAwsAssumeRoleToHclTerraform(struct?: DataDatadogActionConnectionAwsAssumeRole | cdktf.IResolvable): any;
export declare class DataDatadogActionConnectionAwsAssumeRoleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatadogActionConnectionAwsAssumeRole | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatadogActionConnectionAwsAssumeRole | cdktf.IResolvable | undefined);
    get accountId(): string;
    get externalId(): string;
    get principalId(): string;
    get role(): string;
}
export interface DataDatadogActionConnectionAws {
}
export declare function dataDatadogActionConnectionAwsToTerraform(struct?: DataDatadogActionConnectionAws | cdktf.IResolvable): any;
export declare function dataDatadogActionConnectionAwsToHclTerraform(struct?: DataDatadogActionConnectionAws | cdktf.IResolvable): any;
export declare class DataDatadogActionConnectionAwsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatadogActionConnectionAws | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatadogActionConnectionAws | cdktf.IResolvable | undefined);
    private _assumeRole;
    get assumeRole(): DataDatadogActionConnectionAwsAssumeRoleOutputReference;
}
export interface DataDatadogActionConnectionHttpTokenAuthBody {
}
export declare function dataDatadogActionConnectionHttpTokenAuthBodyToTerraform(struct?: DataDatadogActionConnectionHttpTokenAuthBody | cdktf.IResolvable): any;
export declare function dataDatadogActionConnectionHttpTokenAuthBodyToHclTerraform(struct?: DataDatadogActionConnectionHttpTokenAuthBody | cdktf.IResolvable): any;
export declare class DataDatadogActionConnectionHttpTokenAuthBodyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatadogActionConnectionHttpTokenAuthBody | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatadogActionConnectionHttpTokenAuthBody | cdktf.IResolvable | undefined);
    get content(): string;
    get contentType(): string;
}
export interface DataDatadogActionConnectionHttpTokenAuthHeader {
}
export declare function dataDatadogActionConnectionHttpTokenAuthHeaderToTerraform(struct?: DataDatadogActionConnectionHttpTokenAuthHeader | cdktf.IResolvable): any;
export declare function dataDatadogActionConnectionHttpTokenAuthHeaderToHclTerraform(struct?: DataDatadogActionConnectionHttpTokenAuthHeader | cdktf.IResolvable): any;
export declare class DataDatadogActionConnectionHttpTokenAuthHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatadogActionConnectionHttpTokenAuthHeader | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatadogActionConnectionHttpTokenAuthHeader | cdktf.IResolvable | undefined);
    get name(): string;
    get value(): string;
}
export declare class DataDatadogActionConnectionHttpTokenAuthHeaderList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatadogActionConnectionHttpTokenAuthHeader[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatadogActionConnectionHttpTokenAuthHeaderOutputReference;
}
export interface DataDatadogActionConnectionHttpTokenAuthToken {
}
export declare function dataDatadogActionConnectionHttpTokenAuthTokenToTerraform(struct?: DataDatadogActionConnectionHttpTokenAuthToken | cdktf.IResolvable): any;
export declare function dataDatadogActionConnectionHttpTokenAuthTokenToHclTerraform(struct?: DataDatadogActionConnectionHttpTokenAuthToken | cdktf.IResolvable): any;
export declare class DataDatadogActionConnectionHttpTokenAuthTokenOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatadogActionConnectionHttpTokenAuthToken | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatadogActionConnectionHttpTokenAuthToken | cdktf.IResolvable | undefined);
    get name(): string;
    get type(): string;
    get value(): string;
}
export declare class DataDatadogActionConnectionHttpTokenAuthTokenList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatadogActionConnectionHttpTokenAuthToken[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatadogActionConnectionHttpTokenAuthTokenOutputReference;
}
export interface DataDatadogActionConnectionHttpTokenAuthUrlParameter {
}
export declare function dataDatadogActionConnectionHttpTokenAuthUrlParameterToTerraform(struct?: DataDatadogActionConnectionHttpTokenAuthUrlParameter | cdktf.IResolvable): any;
export declare function dataDatadogActionConnectionHttpTokenAuthUrlParameterToHclTerraform(struct?: DataDatadogActionConnectionHttpTokenAuthUrlParameter | cdktf.IResolvable): any;
export declare class DataDatadogActionConnectionHttpTokenAuthUrlParameterOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataDatadogActionConnectionHttpTokenAuthUrlParameter | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatadogActionConnectionHttpTokenAuthUrlParameter | cdktf.IResolvable | undefined);
    get name(): string;
    get value(): string;
}
export declare class DataDatadogActionConnectionHttpTokenAuthUrlParameterList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataDatadogActionConnectionHttpTokenAuthUrlParameter[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataDatadogActionConnectionHttpTokenAuthUrlParameterOutputReference;
}
export interface DataDatadogActionConnectionHttpTokenAuth {
    /**
    * header block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/action_connection#header DataDatadogActionConnection#header}
    */
    readonly header?: DataDatadogActionConnectionHttpTokenAuthHeader[] | cdktf.IResolvable;
    /**
    * token block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/action_connection#token DataDatadogActionConnection#token}
    */
    readonly token?: DataDatadogActionConnectionHttpTokenAuthToken[] | cdktf.IResolvable;
    /**
    * url_parameter block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/action_connection#url_parameter DataDatadogActionConnection#url_parameter}
    */
    readonly urlParameter?: DataDatadogActionConnectionHttpTokenAuthUrlParameter[] | cdktf.IResolvable;
}
export declare function dataDatadogActionConnectionHttpTokenAuthToTerraform(struct?: DataDatadogActionConnectionHttpTokenAuth | cdktf.IResolvable): any;
export declare function dataDatadogActionConnectionHttpTokenAuthToHclTerraform(struct?: DataDatadogActionConnectionHttpTokenAuth | cdktf.IResolvable): any;
export declare class DataDatadogActionConnectionHttpTokenAuthOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatadogActionConnectionHttpTokenAuth | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatadogActionConnectionHttpTokenAuth | cdktf.IResolvable | undefined);
    private _body;
    get body(): DataDatadogActionConnectionHttpTokenAuthBodyOutputReference;
    private _header;
    get header(): DataDatadogActionConnectionHttpTokenAuthHeaderList;
    putHeader(value: DataDatadogActionConnectionHttpTokenAuthHeader[] | cdktf.IResolvable): void;
    resetHeader(): void;
    get headerInput(): cdktf.IResolvable | DataDatadogActionConnectionHttpTokenAuthHeader[] | undefined;
    private _token;
    get token(): DataDatadogActionConnectionHttpTokenAuthTokenList;
    putToken(value: DataDatadogActionConnectionHttpTokenAuthToken[] | cdktf.IResolvable): void;
    resetToken(): void;
    get tokenInput(): cdktf.IResolvable | DataDatadogActionConnectionHttpTokenAuthToken[] | undefined;
    private _urlParameter;
    get urlParameter(): DataDatadogActionConnectionHttpTokenAuthUrlParameterList;
    putUrlParameter(value: DataDatadogActionConnectionHttpTokenAuthUrlParameter[] | cdktf.IResolvable): void;
    resetUrlParameter(): void;
    get urlParameterInput(): cdktf.IResolvable | DataDatadogActionConnectionHttpTokenAuthUrlParameter[] | undefined;
}
export interface DataDatadogActionConnectionHttp {
    /**
    * token_auth block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/action_connection#token_auth DataDatadogActionConnection#token_auth}
    */
    readonly tokenAuth?: DataDatadogActionConnectionHttpTokenAuth;
}
export declare function dataDatadogActionConnectionHttpToTerraform(struct?: DataDatadogActionConnectionHttp | cdktf.IResolvable): any;
export declare function dataDatadogActionConnectionHttpToHclTerraform(struct?: DataDatadogActionConnectionHttp | cdktf.IResolvable): any;
export declare class DataDatadogActionConnectionHttpOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataDatadogActionConnectionHttp | cdktf.IResolvable | undefined;
    set internalValue(value: DataDatadogActionConnectionHttp | cdktf.IResolvable | undefined);
    get baseUrl(): string;
    private _tokenAuth;
    get tokenAuth(): DataDatadogActionConnectionHttpTokenAuthOutputReference;
    putTokenAuth(value: DataDatadogActionConnectionHttpTokenAuth): void;
    resetTokenAuth(): void;
    get tokenAuthInput(): cdktf.IResolvable | DataDatadogActionConnectionHttpTokenAuth | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/action_connection datadog_action_connection}
*/
export declare class DataDatadogActionConnection extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "datadog_action_connection";
    /**
    * Generates CDKTF code for importing a DataDatadogActionConnection resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatadogActionConnection to import
    * @param importFromId The id of the existing DataDatadogActionConnection that should be imported. Refer to the {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/action_connection#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatadogActionConnection to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/action_connection datadog_action_connection} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatadogActionConnectionConfig
    */
    constructor(scope: Construct, id: string, config: DataDatadogActionConnectionConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    get idInput(): string | undefined;
    get name(): string;
    private _aws;
    get aws(): DataDatadogActionConnectionAwsOutputReference;
    private _http;
    get http(): DataDatadogActionConnectionHttpOutputReference;
    putHttp(value: DataDatadogActionConnectionHttp): void;
    resetHttp(): void;
    get httpInput(): cdktf.IResolvable | DataDatadogActionConnectionHttp | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
