/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatadogIntegrationAwsNamespaceRulesConfig extends cdktf.TerraformMetaArguments {
}
/**
* Represents a {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/integration_aws_namespace_rules datadog_integration_aws_namespace_rules}
*/
export declare class DataDatadogIntegrationAwsNamespaceRules extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "datadog_integration_aws_namespace_rules";
    /**
    * Generates CDKTF code for importing a DataDatadogIntegrationAwsNamespaceRules resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatadogIntegrationAwsNamespaceRules to import
    * @param importFromId The id of the existing DataDatadogIntegrationAwsNamespaceRules that should be imported. Refer to the {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/integration_aws_namespace_rules#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatadogIntegrationAwsNamespaceRules to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/integration_aws_namespace_rules datadog_integration_aws_namespace_rules} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatadogIntegrationAwsNamespaceRulesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatadogIntegrationAwsNamespaceRulesConfig);
    get id(): string;
    get namespaceRules(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
