/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataDatadogLogsPipelinesOrderConfig extends cdktf.TerraformMetaArguments {
}
/**
* Represents a {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/logs_pipelines_order datadog_logs_pipelines_order}
*/
export declare class DataDatadogLogsPipelinesOrder extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "datadog_logs_pipelines_order";
    /**
    * Generates CDKTF code for importing a DataDatadogLogsPipelinesOrder resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataDatadogLogsPipelinesOrder to import
    * @param importFromId The id of the existing DataDatadogLogsPipelinesOrder that should be imported. Refer to the {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/logs_pipelines_order#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataDatadogLogsPipelinesOrder to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/data-sources/logs_pipelines_order datadog_logs_pipelines_order} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataDatadogLogsPipelinesOrderConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataDatadogLogsPipelinesOrderConfig);
    get id(): string;
    get pipelineIds(): string[];
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
