/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface SecurityMonitoringRuleJsonConfig extends cdktf.TerraformMetaArguments {
    /**
    * The JSON definition of the Security Monitoring Rule.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/resources/security_monitoring_rule_json#json SecurityMonitoringRuleJson#json}
    */
    readonly json: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/resources/security_monitoring_rule_json datadog_security_monitoring_rule_json}
*/
export declare class SecurityMonitoringRuleJson extends cdktf.TerraformResource {
    static readonly tfResourceType = "datadog_security_monitoring_rule_json";
    /**
    * Generates CDKTF code for importing a SecurityMonitoringRuleJson resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the SecurityMonitoringRuleJson to import
    * @param importFromId The id of the existing SecurityMonitoringRuleJson that should be imported. Refer to the {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/resources/security_monitoring_rule_json#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the SecurityMonitoringRuleJson to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/resources/security_monitoring_rule_json datadog_security_monitoring_rule_json} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options SecurityMonitoringRuleJsonConfig
    */
    constructor(scope: Construct, id: string, config: SecurityMonitoringRuleJsonConfig);
    get id(): string;
    private _json?;
    get json(): string;
    set json(value: string);
    get jsonInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
