/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface SoftwareCatalogConfig extends cdktf.TerraformMetaArguments {
    /**
    * The catalog entity definition. Entity must be a valid entity YAML/JSON structure.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/resources/software_catalog#entity SoftwareCatalog#entity}
    */
    readonly entity: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/resources/software_catalog datadog_software_catalog}
*/
export declare class SoftwareCatalog extends cdktf.TerraformResource {
    static readonly tfResourceType = "datadog_software_catalog";
    /**
    * Generates CDKTF code for importing a SoftwareCatalog resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the SoftwareCatalog to import
    * @param importFromId The id of the existing SoftwareCatalog that should be imported. Refer to the {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/resources/software_catalog#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the SoftwareCatalog to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/datadog/datadog/3.65.0/docs/resources/software_catalog datadog_software_catalog} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options SoftwareCatalogConfig
    */
    constructor(scope: Construct, id: string, config: SoftwareCatalogConfig);
    private _entity?;
    get entity(): string;
    set entity(value: string);
    get entityInput(): string | undefined;
    get id(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
